/*  dvdisaster: Additional error correction for optical media.
 *  Copyright (C) 2004,2005 Carsten Gnoerlich.
 *  Project home page: http://www.dvdisaster.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA,
 *  or direct your browser at http://www.gnu.org.
 */

#include "dvdisaster.h"

/***
 *** Allocate and initialize our global variables
 ***/

GlobalClosure *Closure;

void InitClosure()
{  int v1,v2,v3,dots=0;
   char *v,version[strlen(VERSION)+1];

   Closure = g_malloc0(sizeof(GlobalClosure));

   /* Replace the dot with a locale-resistant separator */

   strcpy(version,VERSION);
   for(v=version; *v; v++)
     if(*v=='.') 
     {  *v='x';
        dots++;
     }

   if(dots == 1) 
   {  sscanf(version,"%dx%d",&v1,&v2);
      v3 = 0;
   }
   else if(dots == 2) sscanf(version,"%dx%dx%d",&v1,&v2,&v3);
   else 
   {  g_printf("Error: malformed version number %s\n",VERSION);
      exit(EXIT_FAILURE);
   }

   Closure->version = 10000*v1 + 100*v2 + v3;

   /* Fill in other closure defaults */

   Closure->methodName = g_strdup("RS01");
   Closure->cacheMB    = 32;
   Closure->sectorSkip = 16;
}

#define cond_free(x) if(x) g_free(x)

void FreeClosure()
{
   cond_free(Closure->methodName);
   cond_free(Closure->deadSector);
   g_free(Closure);
}
