/*  dvdisaster: Additional error correction for optical media.
 *  Copyright (C) 2004,2005 Carsten Gnoerlich.
 *  Project home page: http://www.dvdisaster.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA,
 *  or direct your browser at http://www.gnu.org.
 */

#include "dvdisaster.h"

/***
 *** Collect the available methods
 ***/

/*
 * Invite all methods for registration 
 */

void CollectMethods(void)
{
  BindMethods();
}

/*
 * All methods register by calling this 
 */

static int n_methods = 0;
static Method **methods = NULL;

void RegisterMethod(Method *method)
{
  methods = g_realloc(methods, (n_methods+1)*sizeof(Method*));
  
  methods[n_methods++] = method;
}

/*
 * List the available methods
 */

void ListMethods(void)
{  char name[5];
   int i;

   PrintMsg(_("\nList of available methods:\n\n"));
   name[4] = 0;
 
   for(i=0; i<n_methods; i++)
   {  
      strncpy(name, methods[i]->name, 4);
      PrintMsg("%s -- %s\n",name,methods[i]->description);
   }
}

/*
 * Find a method by name
 */

Method *FindMethod(char *name)
{  int i;

   for(i=0; i<n_methods; i++) 
     if(!strncmp(methods[i]->name, name, 4))
       return methods[i];

   return NULL;
}
